/* Problem URL: https://codeforces.com/contest/2156/problem/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

const int MAXN = 2e5 + 1;
int lim[MAXN];

void pre()
{
    nrep(i, 1, MAXN) {
        int low = 1;
        int high = i / 3;
        int ans = 0;
        while (low <= high) {
            int mid = (low + high) >> 1;

            int cur = i - mid * 2;
            int dis = cur % mid;

            if (cur - dis >= mid + dis) {
                ans = mid;
                low = mid + 1;
                continue;
            }

            high = mid - 1;
        }

        lim[i] = ans;
    }
}

#define TEST 1

void solve()
{
    int n, k;
    cin >> n >> k;

    vi a(n);
    cin >> a;

    vi count(n + 1);
    auto getdivs = [&](int now) {
        for (int i = 1; i * i <= now; i++) {
            if (now % i == 0) {
                count[i]++;
                if (i * i != now) {
                    count[now / i]++;
                }
            }
        }
    };

    vvi rem(n + 2);

    rep(i, n) {
        rem[lim[a[i]] + 1].push_back(a[i]);
    }

    int ans = 1;
    int c = 0;

    nrep(i, 1, n + 1) {
        repv(j, rem[i]) {
            getdivs(j);
            c++;
        }

        int cur = c - count[i];
        if (cur <= k) {
            ans = i;
        }
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
